#!/bin/bash

###############################
### Shell Variable
###############################

# Failed Flag : 0=OK, 1=NG
FAIL_FLG=0

# A1.1.0 Directory & Filename of MegaCli
MEGACLI_DIR=/opt/MegaRAID/MegaCli/
MEGACLI_NAME=""

rm -f "$MEGACLI_DIR"RESULT.txt > /dev/null

############################################
#  Ver.1.0.0 2009/09/14 Support wish MegaCLI Ver.1.01.39
############################################

###############################
### MegaCli install check
###############################

rpm -qa | grep MegaCli > /dev/null

 if [ $? -ne 0 ];then
  echo -------------------------
  echo MegaCli is not installed.
  echo Please install MegaCli.
  echo -------------------------
  exit 1
 fi

###############################
### MegaCli Filename Select A1.1.0
###############################

uname -m | grep 'x86_64' > /dev/null     # x64
if [ $? -eq 0 ]; then
  MEGACLI_NAME=MegaCli64
#  uname -r | grep 'AX' > /dev/null     # ML
#  if [ $? -eq 0 ]; then
#    MEGACLI_NAME=MegaCli
#  fi
else
  MEGACLI_NAME=MegaCli
fi

###############################
### DAC select & Set PR
###############################

echo "" >> "$MEGACLI_DIR"RESULT.txt

 for i in `seq 0 3`
 do
  {
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$i
  } >> "$MEGACLI_DIR"a$i.log

  grep "Failed to get CpController object." "$MEGACLI_DIR"a$i.log > /dev/null

  if [ $? -eq 0 ];then
  {
  echo "" >> "$MEGACLI_DIR"RESULT.txt
  }
  else
  {
   grep "FW Version         : 1.12.152-0589" "$MEGACLI_DIR"a$i.log > /dev/null
   if [ $? -eq 0 ];then
   {
   echo "Adapter $i: Already updated!!!" >>"$MEGACLI_DIR"RESULT.txt

   $MEGACLI_DIR$MEGACLI_NAME -AdpPR -EnblMan -a$i > /dev/null
   $MEGACLI_DIR$MEGACLI_NAME -AdpPR -Stop -a$i > /dev/null
   $MEGACLI_DIR$MEGACLI_NAME -AdpPR -SetDelay 228 -a$i > /dev/null
   $MEGACLI_DIR$MEGACLI_NAME -AdpPR -EnblAuto -a$i > /dev/null
    if [ $? -eq 0 ];then
    {
    echo "Adapter $i: Set PR COMPLETED!!" >> "$MEGACLI_DIR"RESULT.txt
    echo "" >> "$MEGACLI_DIR"RESULT.txt
    }
    else
    {
    echo "Adapter $i: Set PR FAILED!!" >> "$MEGACLI_DIR"RESULT.txt
    echo "" >> "$MEGACLI_DIR"RESULT.txt
    }
    fi
   }
   else
   {
   grep "FW Version         : 1.12" "$MEGACLI_DIR"a$i.log > /dev/null
    if [ $? -eq 1 ];then
    {
    echo "Adapter $i: Not target adapter!!!" >>"$MEGACLI_DIR"RESULT.txt
    echo "" >> "$MEGACLI_DIR"RESULT.txt
    }
    else
    {
    $MEGACLI_DIR$MEGACLI_NAME -AdpFwFlash -f fw.rom -NoSigChk -NoVerChk -a$i > /dev/null
     if [ $? -eq 0 ];then
     {
     echo "Adapter $i: FW Update COMPLETED!!" >> "$MEGACLI_DIR"RESULT.txt
     }
     else
     {
     echo "Adapter $i: FW Update FAILED!!" >> "$MEGACLI_DIR"RESULT.txt
     }
     fi

    $MEGACLI_DIR$MEGACLI_NAME -AdpPR -EnblMan -a$i > /dev/null
				$MEGACLI_DIR$MEGACLI_NAME -AdpPR -Stop -a$i > /dev/null
				$MEGACLI_DIR$MEGACLI_NAME -AdpPR -SetDelay 228 -a$i > /dev/null
				$MEGACLI_DIR$MEGACLI_NAME -AdpPR -EnblAuto -a$i > /dev/null
					if [ $? -eq 0 ];then
					{
					echo "Adapter $i: Set PR COMPLETED!!" >> "$MEGACLI_DIR"RESULT.txt
					echo "" >> "$MEGACLI_DIR"RESULT.txt
					}
					else
					{
					echo "Adapter $i: Set PR FAILED!!" >> "$MEGACLI_DIR"RESULT.txt
     echo "" >> "$MEGACLI_DIR"RESULT.txt
     }
     fi
    }
    fi
   }
   fi
  }
  fi 
 done

grep "Failed to get CpController object." "$MEGACLI_DIR"a0.log > /dev/null

 if [ $? -eq 0 ];then
 {
 echo "Not Target System" >> "$MEGACLI_DIR"RESULT.txt
 }
 fi
cat "$MEGACLI_DIR"RESULT.txt
rm -f "$MEGACLI_DIR"*.log > /dev/null
exit $FAIL_FLG
